//                                                        
//    LEDs on and servo moving when Attention is high      
//    December 1, 2020                                     
//    Arduino with HC-05 Bluetooth and NeuroSky MindWave Mobile 2 
//           Yellow LED on when Attn more than 50
//           Green LED on when Attn more than 70
//           Servo moves 90 degrees when Attn is more than 50

#include<Servo.h>
#define BAUDRATE 57600
#define YLED 4
#define GLED 2

//////////    Variables 
Servo myservo;
byte payloadData[32] = {0};
byte Attention[5]={0};
byte checksum=0;
byte generatedchecksum=0;
int  Plength,Temp;
int  Att_Avg=0;
int  k=0;
signed int  j=0;

//////////    Arduino setup
void setup() 
{
  Serial.begin(BAUDRATE);  
  pinMode(YLED, OUTPUT);
  pinMode(GLED, OUTPUT);
  Serial.println("Average Attention Values");
  myservo.attach(9);
  myservo.write(0);
  delay(15);
}

//////////    Read data 
byte ReadOneByte()
{
  int ByteRead;
  while(!Serial.available());
  ByteRead = Serial.read();
  return ByteRead;
}

//////////    Main program
void loop() 
{

//////    Look for sync bytes and read data
  while (1)
  {
    if(ReadOneByte() == 170) 
    {
      if(ReadOneByte() == 170) 
      {
        Plength = ReadOneByte();
        if(Plength == 32) 
        {
          generatedchecksum = 0;
          for(int i = 0; i < Plength; i++) 
          {  
            payloadData[i]     = ReadOneByte();  
            generatedchecksum  += payloadData[i] ;
          }
          generatedchecksum = 255 - generatedchecksum;
          checksum  = ReadOneByte();

//////    Obtain Attention data and calculate an average         
          if(checksum == generatedchecksum) 
          {             
            if (payloadData[28]==4)
            { 
              if (j<4)
               {
                 Attention [k] = payloadData[29];
                 Temp += Attention [k];
                 j++;
               }
               else
               {
                 Att_Avg = Temp/4; 
//////    Display average Attention in Serial Monitor, move servo, and light LEDs
                 Serial.println(Att_Avg, DEC);
//    The next 2 statements would move the servo based on average Attention level.
//    Attention level is between 0 and 100, moving servo between 0 and 100 degrees.
//    But they are now comments because I decided to move the servo 90 degrees
//    when average Attention is higher than 60.
//                 myservo.write(Att_Avg);
//                 delay(15);
                 if (Att_Avg>50)
                 {
                 digitalWrite(YLED, HIGH);
                 myservo.write(90);
                 delay(15);
                 }
                 else
                 {
                 digitalWrite(YLED, LOW);
                 myservo.write(0);
                 delay(15);                }
                 if(Att_Avg>70)
                 {
                 digitalWrite(GLED, HIGH);
                 }
                 else
                 {
                 digitalWrite(GLED, LOW);
                 }
                 j=0;
                 Temp=0;
               }
            }
           } 
         }
       }
     }         
   }
}
 
